unit Main_F;

{Startovni cislo 37}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TMapa = array of array of Char;
  TVektor = record
    x: integer;
    y: integer;
  end;
  TMainForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PaintBox1: TPaintBox;
    Button1: TButton;
    Button2: TButton;
    OpenDialog1: TOpenDialog;
    Button3: TButton;
    Shape1: TShape;
    Label1: TLabel;
    Shape2: TShape;
    Label2: TLabel;
    Shape3: TShape;
    Label3: TLabel;
    Shape4: TShape;
    Label4: TLabel;
    Shape5: TShape;
    Label5: TLabel;
    Label6: TLabel;
    Shape6: TShape;
    Shape7: TShape;
    Label7: TLabel;
    Bevel1: TBevel;
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Mapa: TMapa;
    ForceBreak: boolean;
    procedure NactiMapu(Filename: string; var Mapa: TMapa);
    procedure KresliMapu(Bitmap: TBitmap; Mapa: TMapa; Auto: TPoint; JenAuto: boolean = false);
//    procedure Projed;
    procedure Projed2;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.NactiMapu(Filename: string; var Mapa: TMapa);
var
  F: TextFile;
  s: string;
  i, j: integer;
begin
  AssignFile(F, Filename);
  Reset(F);
  j := 0;
  while not Eof(F) do
  begin
    Readln(F, s);
    SetLength(Mapa, Length(s), j+1);
    for i := 1 to Length(s) do
    begin
      Mapa[i-1, j] := s[i];
      if not (UpCase(s[i]) in ['X', 'C', '.', ':', 'S']) then
        ShowMessage('Chybny znakv souboru "'+s[i]+'"');
    end;  
    Inc(j);  
  end;
end;

procedure TMainForm.KresliMapu(Bitmap: TBitmap; Mapa: TMapa; Auto: TPoint; JenAuto: boolean = false);
var
  x, y: integer;
  C: TColor;
begin
  for x := 0 to Length(Mapa)-1 do             
    for y := 0 to Length(Mapa[0])-1 do
    begin
      case UpCase(Mapa[x, y]) of
        'X': C := clGray;
        'S': C := clBlue;
        'C': C := clFuchsia;
        ':': C := clLime;
        '.': C := clGreen;
        '-': C := clYellow;
        '*': C := clAqua;
      end;
      if (Auto.X = x) and (Auto.Y = y) then
        C := clWhite;

      with Bitmap.Canvas do
      begin
        if (not JenAuto) or (C = clWhite) or (C = clAqua) then
        begin
          Brush.Color := C;
          FillRect(Rect(Bitmap.Width*x div Length(Mapa), Bitmap.Height*y div Length(Mapa[0]), Bitmap.Width*(x+1) div Length(Mapa), Bitmap.Height*(y+1) div Length(Mapa[0])));
        end;  
      end;
    end;
end;

procedure TMainForm.PaintBox1Paint(Sender: TObject);
var
  Bitmap: TBitmap;
begin
  Bitmap := TBitmap.Create;
  Bitmap.Width := PaintBox1.Width;
  Bitmap.Height := PaintBox1.Height;
  KresliMapu(Bitmap, Mapa, Point(0, 0));
  PaintBox1.Canvas.Draw(0, 0, Bitmap);
  Bitmap.Free;
end;

{procedure TMainForm.Projed;

  procedure RotV45(var V: TVektor);
  begin
    if (V.y = -1) and (V.x < 1) then
    begin
      Inc(V.x);
      Exit;
    end;

    if (V.x = 1) and (V.y < 1) then
    begin
      Inc(V.y);
      Exit;
    end;

    if (V.y = 1) and (V.x > -1) then
    begin
      Dec(V.x);
      Exit;
    end;

    if (V.x = -1) and (V.y > -1) then
    begin
      Dec(V.y);
      Exit;
    end;
  end;

  procedure NRotV45(var V: TVektor);
  begin
    if (V.y = -1) and (V.x > -1) then
    begin
      Dec(V.x);
      Exit;
    end;

    if (V.x = 1) and (V.y > -1) then
    begin
      Dec(V.y);
      Exit;
    end;

    if (V.y = 1) and (V.x < 1) then
    begin
      Inc(V.x);
      Exit;
    end;

    if (V.x = -1) and (V.y < 1) then
    begin
      Inc(V.y);
      Exit;
    end;
  end;

var
  sx, sy, x, y: integer;
  Bitmap: TBitmap;
  v: TVektor;

  Okraje: array of array of boolean;
begin
  SetLength(Okraje, Length(Mapa), Length(mapa[0]));
  Bitmap := TBitmap.Create;
  Bitmap.Width := PaintBox1.Width;
  Bitmap.Height := PaintBox1.Height;
  for x := 0 to Length(Mapa)-1 do
    for y := 0 to Length(Mapa[0])-1 do
      if Mapa[x, y] = 'S' then
      begin
        sx := x;
        sy := y;
      end;
  x := sx;
  y := sy;

  v.y := 1;
  v.x := 0;
  KresliMapu(Bitmap, Mapa, Point(x, y));
  repeat
    KresliMapu(Bitmap, Mapa, Point(x, y), true);
    PaintBox1.Canvas.Draw(0, 0, Bitmap);
    Application.ProcessMessages;
    while Mapa[x+v.x, y+v.y] = 'X' do
    begin
      RotV45(v);

      if Mapa[x+v.x, y+v.y] = 'X' then
      begin
        NRotV45(v);
        NRotV45(v);
      end;

      Application.ProcessMessages;
      if ForceBreak then Break;
    end;
    x := x + v.x;
    y := y + v.y;

    
  until (Mapa[x, y] = 'C') or ForceBreak;
  Bitmap.Free;
end;
}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ForceBreak := false;
  NactiMapu('Test\Mapa06.txt', Mapa);
end;

procedure TMainForm.Button2Click(Sender: TObject);
begin
  ForceBreak := true;
end;

procedure TMainForm.Button1Click(Sender: TObject);
begin
  ForceBreak := false;
  Projed2;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ForceBreak := true;
end;

procedure TMainForm.Button3Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    NactiMapu(OpenDialog1.FileName, Mapa);
  PaintBox1.Repaint;
end;

procedure TMainForm.Projed2;
var
  i, sx, sy, x, y, px, py: integer;
  PresCaru: Boolean;
  Bitmap: TBitmap;
  Body: array of TPoint;
  v: TPoint;

label
  Dal;


function Cara(x1, y1, x2, y2: integer; var px, py: integer): boolean; {Zjisteni protnuti travy}
var
  x, y: integer;
begin
  Result :=false;

  if Abs(x2-x1) < Abs(y2-y1) then
  begin
    if y2 > y1 then
      for y := y1 to y2 do
      begin
        x := Round(x1+(y-y1)/(y2-y1)*(x2-x1));
        if Mapa[x, y] = 'X' then
        begin
          Result := true;
          px := x;
          py := y;
        end;
      end;

    if y2 < y1 then
      for y := y1 downto y2 do
      begin
        x := Round(x1+(y-y1)/(y2-y1)*(x2-x1));
        if Mapa[x, y] = 'X' then
        begin
          Result := true;
          px := x;
          py := y;
        end;
      end;

    if y2 = y1 then
      for x := x1 to x2 do
        if Mapa[x, y] = 'X' then
        begin
          Result := true;
          px := x;
          py := y;
        end;
  end else
  begin
    if x2 > x1 then
      for x := x1 to x2 do
      begin
        y := Round(y1+(x-x1)/(x2-x1)*(y2-y1));
        if Mapa[x, y] = 'X' then
        begin
          Result := true;
          px := x;
          py := y;
        end;
      end;

    if x2 < x1 then
      for x := x1 downto x2 do
      begin
        y := Round(y1+(x-x1)/(x2-x1)*(y2-y1));
        if Mapa[x, y] = 'X' then
        begin
          Result := true;
          px := x;
          py := y;
        end;
      end;

    if x2 = x1 then
    begin
      x := x1;
      for y := y1 to y2 do
        if Mapa[x, y] = 'X' then
        begin
          Result := true;
          px := x;
          py := y;
        end;
    end;
  end;

end;

begin

  Bitmap := TBitmap.Create;
  Bitmap.Width := PaintBox1.Width;
  Bitmap.Height := PaintBox1.Height;

  for x := 0 to Length(Mapa)-1 do
    for y := 0 to Length(Mapa[0])-1 do
      if Mapa[x, y] = 'S' then
      begin
        sx := x;
        sy := y;
      end;

  KresliMapu(Bitmap, Mapa, Point(sx, sy));
  PaintBox1.Canvas.Draw(0, 0, Bitmap);

  PresCaru := false;
  x := sx;
  y := sy;
  repeat

    for px := -1 to 1 do
      for py := -1 to 1 do
        if (x+px >= 0) and (x+px < Length(Mapa)) and (y+py >= 0) and (y+py < Length(Mapa[0])) then
          if Mapa[x+px, y+py] = ':' then
          begin
            Mapa[x, y] := 'q';
            x := x + px;
            y := y + py;
            goto Dal;
          end;
    Dal:

    SetLength(Body, 1);
    Body[0] := Point(sx, sy);

    if Cara(sx, sy, x, y, px, py) then
    begin
      Mapa[px, py] := '*';
      SetLength(Body, Length(Body)+1);
      with Body[Length(Body)-1] do
      begin
        x := px;
        y := py;
      end;

      sx := px;
      sy := py;
    end;  

    KresliMapu(Bitmap, Mapa, Point(x, y), true);
    PaintBox1.Canvas.Draw(0, 0, Bitmap);
    Application.ProcessMessages;

  until ForceBreak;

  v := Point(0, 0);

  for i := 0 to Length(Body)-2 do
  begin
    px := Body[i+1].X - Body[i+1].X;
    py := Body[i+1].Y - Body[i+1].Y;

    if V.X < px then Inc(v.X);
    if V.X > px then Dec(v.X);

    if V.Y < py then Inc(v.Y);
    if V.Y > py then Dec(v.Y);
  end;

  {
    Mam ziskane body, kde se zakrivuje draha. Dale osetrim jestli nektere body nejsou primo viditelne pomoci funkce Cara.
    Pak budu mit hotovy seznam bodu nejkratsi trasy, ale zatim bez uvazeni pozadavku na malou zmenu smeru.
  }
end;


end.


